# -*- coding: utf-8 -*-
#!/usr/bin/env python

import pyaudio
import wave
import numpy as np
from BrainAction import BrainAction

#設定
CHUNK = 1024*2
FORMAT = pyaudio.paInt16
CHANNELS = 1
RATE = 16000

RECORD_SECONDS = 5#録音時間
threshold = 0.2#キャッチする音量


#処理用のインスタンスの生成
BrainAction=BrainAction()
BrainAction.google_key='googleサービスキー'
BrainAction.google_url='中継サーバーURL'#追加
BrainAction.dialogF_token='DialogFlow アクセストークン'
BrainAction.docomo_key='docomo APIキー'
voicefile1='voice.wav'



#音声を拾う
p = pyaudio.PyAudio()

stream = p.open(format = FORMAT,
    channels = CHANNELS,
    rate = RATE,
    input = True,
    frames_per_buffer = CHUNK
)


while True:
    
    data = stream.read(CHUNK,exception_on_overflow = False)

    x = np.frombuffer(data, dtype="int16") / 32768.0#intの最大値

    #設定した音量より大きい場合に録音データ(ファイル)を作成する
    print (x.max())
    if x.max() > threshold:
        print("Recording")



        all = []
        all.append(data)
        for i in range(0, int(RATE / CHUNK * int(RECORD_SECONDS))):
            data = stream.read(CHUNK,exception_on_overflow = False)
            all.append(data)
        data = b''.join(all)

        out = wave.open(voicefile1,'w')
        out.setnchannels(CHANNELS)
        out.setsampwidth(2)
        out.setframerate(RATE)
        out.writeframes(data)
        out.close()

        print("Saved")

        #フラグにより最初のアクションか、続きのアクション制御
        #各々のアクションはBrainActionというクラスで処理する。
        print(BrainAction.flg_action)
        if BrainAction.flg_action=='ini':
            BrainAction.Action_1st(voicefile1)
        else:
            BrainAction.Action_2nd(voicefile1)

    
#終了処理
stream.close()
p.terminate()
